export declare class Color {
    constructor(value?: string | number);
    static Transparent: Readonly<Color>;
    /** Animal Crossing New Leaf color code. */
    acnlByte: number;
    /** Hex string representation of the color (e.g., "#FFAA00"). */
    get hex(): string | undefined;
    set hex(value: string | undefined);
    /** Hex number representation of the color with the alpha channel (e.g., 0xFFAA00FF). */
    get hexNumber(): number | undefined;
    private byteToHex;
    private hexToByte;
    private normalizeHex;
    static readonly newLeafColorCodes: (string | undefined)[];
    static readonly newLeafColors: (string | undefined)[];
}
