import { DesignType } from './DesignType';
import { ImageSize } from './ImageSize';
interface DesignUsageParameters {
    id: number;
    description: string;
    type: DesignType;
    imageSize: ImageSize;
}
export declare class DesignUsage {
    readonly id: number;
    readonly description: string;
    readonly type: DesignType;
    readonly imageSize: ImageSize;
    constructor(params: DesignUsageParameters);
    get width(): number;
    get height(): number;
    get pixelCount(): number;
    get imageDataByteLength(): number;
    get byteLength(): number;
    get qrCodeCount(): number;
    static readonly LongSleeveDress: DesignUsage;
    static readonly ShortSleeveDress: DesignUsage;
    static readonly SleevelessDress: DesignUsage;
    static readonly LongSleeveShirt: DesignUsage;
    static readonly ShortSleeveShirt: DesignUsage;
    static readonly SleevelessShirt: DesignUsage;
    static readonly HornedHat: DesignUsage;
    static readonly KnitCap: DesignUsage;
    static readonly Standee: DesignUsage;
    static readonly CustomDesign: DesignUsage;
    static readonly UnknownUsage010: DesignUsage;
    static readonly UnknownUsage011: DesignUsage;
    static readonly all: DesignUsage[];
    static fromId(id: number): DesignUsage | undefined;
}
export {};
