"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const qrcode_1 = __importDefault(require("qrcode"));
const Image_1 = require("./images/Image");
const canvas_1 = require("canvas");
class QRData {
    constructor(bytes, index, parity) {
        this.bytes = bytes;
        this.index = index;
        this.parity = parity;
    }
    // QR code conversion
    qrSegments() {
        const segments = [{ mode: 'byte', data: this.bytes }];
        if (this.index !== undefined && this.parity !== undefined) {
            segments.unshift({ mode: 'structuredappend', data: { position: this.index, total: 3, parity: this.parity } });
        }
        return segments;
    }
    toImage() {
        const canvas = canvas_1.createCanvas(1, 1);
        qrcode_1.default.toCanvas(canvas, this.qrSegments());
        return Image_1.Image.fromCanvas(canvas);
    }
}
exports.QRData = QRData;
