/// <reference types="node" />
import { Canvas } from 'canvas';
import { ImageFilter } from './ImageFilter';
export declare class Image {
    width: number;
    height: number;
    data: Uint32Array;
    constructor(width: number, height: number, data: Uint32Array);
    static fromCanvas(canvas: Canvas | HTMLCanvasElement): Image;
    applyFilter(filter: ImageFilter): Promise<Image>;
    applyXbrzUpscaling(scale?: 2 | 3 | 4 | 5 | 6): Promise<Image>;
    toCanvas(): Canvas | HTMLCanvasElement;
    toCanvas(canvas: Canvas | HTMLCanvasElement): Canvas | HTMLCanvasElement;
    toCanvas(canvas: Canvas | HTMLCanvasElement, x: number, y: number): Canvas | HTMLCanvasElement;
    toCanvas(context: CanvasRenderingContext2D): Canvas | HTMLCanvasElement;
    toCanvas(context: CanvasRenderingContext2D, x: number, y: number): Canvas | HTMLCanvasElement;
    toDataURL(mimeType?: 'image/png' | 'image/jpeg'): string;
    toBlob(mimeType: 'image/png' | 'image/jpeg'): Promise<Blob>;
    toBuffer(mimeType?: 'image/png' | 'image/jpeg'): Promise<Buffer>;
    toFile(path: string, mimeType?: 'image/png' | 'image/jpeg'): Promise<void>;
    private resolveCanvas;
    private resolveContext;
    private getImageData;
}
