import { IndexedImageBase } from './IndexedImageBase';
import { Design } from '../Design';
import { ColorPalette } from '../ColorPalette';
export declare class IndexedImage extends IndexedImageBase {
    design?: Design;
    constructor(width: number, height: number, design?: Design);
    get colorPalette(): ColorPalette;
    getColorIndexAt(x: number, y: number): number;
    setColorIndexAt(x: number, y: number, value: number): void;
    /**
     * This notifies Vue that the data contained within this object has changed
     * (if this object has been added to a Vue component/made reactive).
     *
     * This is a bit of a hack which is needed because Vue 2.x doesn't make
     * TypedArrays (like Uint8Array) reactive by default. Array<number> doesn't
     * work either because setting values via array index can't be picked up by
     * Vue 2.x's reactivity system (https://vuejs.org/v2/guide/reactivity.html).
     *
     * Making the entire pixel array reactive comes with a significant performance
     * penalty in certain cases, so it's probably better overall to keep Design
     * classes out of Vue's data management and update fields/draw images manually.
     * This may be removed in the future.
     */
    private notifyVue;
    private _colorIndexes;
    get colorIndexes(): Uint8Array;
    set colorIndexes(value: Uint8Array);
}
