import { Image } from './Image';
import { ColorPalette } from '../ColorPalette';
export declare abstract class IndexedImageBase {
    readonly width: number;
    readonly height: number;
    constructor(width: number, height: number);
    protected dataSize(): number;
    protected getPixelIndex(x: number, y: number): number;
    abstract get colorPalette(): ColorPalette;
    abstract getColorIndexAt(x: number, y: number): number;
    abstract setColorIndexAt(x: number, y: number, value: number): void;
    get colorIndexes(): Uint8Array;
    set colorIndexes(value: Uint8Array);
    getSegment(x: number, y: number, width: number, height: number): IndexedImageBase;
    toImage(): Image;
    protected validateDataSize(data: Uint8Array): void;
    validateCoordinates(x: number, y: number): void;
}
