"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const IndexedImageBase_1 = require("./IndexedImageBase");
class IndexedImageSegment extends IndexedImageBase_1.IndexedImageBase {
    constructor(source, x, y, width, height) {
        super(width, height);
        source.validateCoordinates(x, y);
        if (width < 0 || width > source.width - x) {
            throw new Error(`Invalid width, must be between 0 and ${x + source.width}`);
        }
        if (height < 0 || height > source.height - y) {
            throw new Error(`Invalid height, must be between 0 and ${y + source.height}`);
        }
        this.source = source;
        this.x = x;
        this.y = y;
    }
    get colorPalette() {
        return this.source.colorPalette;
    }
    getColorIndexAt(x, y) {
        return this.source.getColorIndexAt(x + this.x, y + this.y);
    }
    setColorIndexAt(x, y, value) {
        this.source.setColorIndexAt(x + this.x, y + this.y, value);
    }
}
exports.IndexedImageSegment = IndexedImageSegment;
