"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const Image_1 = require("./Image");
const xbrz_js_1 = require("./PixelFilterJS/xbrz.js");
const Common_js_1 = require("./PixelFilterJS/Common.js");
class XbrzImageFilter {
    constructor(scale = 4) {
        this.scale = scale;
    }
    apply(image) {
        return __awaiter(this, void 0, void 0, function* () {
            const filter = new xbrz_js_1.Filter();
            const data = filter.Apply(image.data, image.width, image.height, this.scale, true);
            return new Image_1.Image(Common_js_1.Common.SizeX, Common_js_1.Common.SizeY, data);
        });
    }
}
exports.XbrzImageFilter = XbrzImageFilter;
